
;------------;
; Spike Hell ;
;------------;
; Initial XY positions set by generating sprite.
; Same applies for speed values

!Pal = $35 ; YXPPCCCT
!YInteractSmOrDu = $20 ; How many pixels to interact with small or ducking Mario, vertically.
!YInteractSmNorDu = $30 ; How many pixels to interact with powerup Mario (not ducking), vertically.

OAMStuff:
db $40,$44,$48,$4C,$D0,$D4,$D8,$DC,$80,$84,$88,$8C,$B0,$B4,$B8,$BC,$C0,$C4,$C8,$CC

Main:
LDA $9D				; \ Don't move if sprites are supposed to be frozen.
BNE Immobile			; /
LDA $1E02,y                     ; \
CLC				;  |
ADC $1E66,y                ;  | Movement.
STA $1E02,y                     ; /
LDA $1E2A,y
ADC #$00
STA $1E2A,y
LDA $1E66,y
BPL NoXORing
EOR #$FF
INC A

NoXORing:
CLC
ADC $1E52,y
CMP #$F0
BCS OkNoMore
STA $1E52,y

OkNoMore:
LDA $94				; \ Sprite <-> Mario collision routine starts here.
SEC                             ;  | X collision = #$18 pixels. (#$0C left, #$0C right.)
SBC $1E16,y                     ;  |
STA $00
LDA $95
SBC $1E3E,y
STA $01
LDA $00
CLC                             ;  |
ADC #$0C			;  |
STA $00
LDA $01
ADC #$00
STA $01
REP #$20
LDA $00
CMP #$0018			;  |
SEP #$20
BCS Immobile			; /
LDA #!YInteractSmOrDu           ; Y collision routine starting here.
LDX $73
BNE StoreToNill
LDX $19
BEQ StoreToNill
LDA #!YInteractSmNorDu

StoreToNill:
STA $00
LDA $96
SEC
SBC $1E02,y
CLC
ADC #$20
CMP $00
BCS Immobile
JSL $00F5B7			; Hurt Mario if sprite is interacting.

Immobile:                       ; OAM routine starts here.
JSR GETDRAW
LDX.w OAMStuff,y 		; Get OAM index.
LDA $00
STA $0200,x			; /
LDA $01			
STA $0201,x			; /
LDA #$E0			; \ Tile = #$E0.
STA $0202,x                     ; / (Spike.)
LDA $1E66,y
BPL NoXORinga
LDA.b #!Pal|$80
BRA Stuffga

NoXORinga:
LDA.b #!Pal

Stuffga:
STA $0203,x			; /
PHX
TXA
LSR
LSR
TAX
LDA $1E8E,y
BEQ OkaySauce
LDA #$03
BRA Rejoisauce

OkaySauce:
LDA #$02

Rejoisauce:
STA $0420,x
PLX
LDA $0201,x
CMP #$EB
BCC ReturnToTheRTSCommandMyChocolate
CMP #$F1                                        ; As soon as the spike is off-screen...
BCS ReturnToTheRTSCommandMyChocolate
LDA $1E52,y
CMP #$30
BCC ReturnToTheRTSCommandMyChocolate

KillSpriteStuff:
LDA #$00					; Kill sprite.
STA $1892,y					;
STA $1E02,y
STA $1E16,y
STA $1E2A,y
STA $1E3E,y
STA $1E52,y
STA $1E66,y
STA $1E8E,y

ReturnToTheRTSCommandMyChocolate:
RTS

GETDRAW:
LDA #$00
STA $1E8E,y
LDA $1E3E,y
XBA
LDA $1E16,y
REP #$20
SEC
SBC $1A
CLC
ADC #$0040
CMP #$0180
SEP #$20
BCS INVALID
LDA $1E3E,y
XBA
LDA $1E16,y
REP #$20
SEC
SBC $1A
CMP #$FFC0
SEP #$20
BCC NOTINVALID
LDA #$01
STA $1E8E,y

NOTINVALID:
LDA $1E3E,y
XBA
LDA $1E16,y
REP #$20
SEC
SBC $1A
SEC
SBC #$0100
CMP #$0040
SEP #$20
BCS NOTINVALID2
LDA #$01
STA $1E8E,y

NOTINVALID2:
LDA $1E16,y
SEC
SBC $1A
STA $00
LDA $1E02,y
SEC
SBC $1C
STA $01
RTS

INVALID:
PLA
PLA
JMP KillSpriteStuff